#!/usr/bin/env python
# -*- coding: utf-8 -*-

import serial
import struct
import math
import numpy as np
import matplotlib.pyplot as plt

ser = serial.Serial("/dev/ttyAMA0",115200)

kSync1 = 0x55
kSync2 = 0xaa
kSync3 = 0x03
kSync4 = 0x08

ranges =[0] * 361
intensities =[0] * 361
x = [0] * 360
y = [0] * 360

def CamsenseX1_parse():
    State = 'SYNC1'
    buf = [0]
    bufU =[0]
    bufL =[0]
    frame_data = [0] * 100
    global    ranges
    global    intensities
    while 1:
        if State == 'SYNC1':
                buf = list(struct.unpack_from("B",ser.read(),0))
                if buf[0] == kSync1:
                        State = 'SYNC2'
        elif State == 'SYNC2':
                buf = list(struct.unpack_from("B",ser.read(),0))
                if buf[0] == kSync2:
                        State = 'SYNC3'
                else:
                        State = 'SYNC1'
        elif State == 'SYNC3':
                buf = list(struct.unpack_from("B",ser.read(),0))
                if buf[0] == kSync3:
                        State = 'SYNC4'
                else:
                        State = 'SYNC1'
        elif State == 'SYNC4':
                buf = list(struct.unpack_from("B",ser.read(),0))
                if buf[0] == kSync4:
                        State = 'SPEED'
                else:
                        State = 'SYNC1'
        elif State == 'SPEED':
                bufL = list(struct.unpack_from("B",ser.read(),0))
                bufU = list(struct.unpack_from("B",ser.read(),0))
                speed = bufU[0] << 8 | bufL[0]
                State = 'START'
        elif State == 'START':
                bufL = list(struct.unpack_from("B",ser.read(),0))
                bufU = list(struct.unpack_from("B",ser.read(),0))
                count  = bufU[0] << 8 | bufL[0]
                start_angle = (count / 64.0) - 640
                State = 'DATA'
        elif State == 'DATA':
                for d in range(24):
                        buf = list(struct.unpack_from("B",ser.read(),0))
                        frame_data[d] = buf[0]
                State = 'END'
        elif State == 'END':
                bufL = list(struct.unpack_from("B",ser.read(),0))
                bufU = list(struct.unpack_from("B",ser.read(),0))
                count = bufU[0] << 8 | bufL[0]
                end_angle = (count / 64.0) - 640
                State = 'CRC'
        elif State == 'CRC':
                buf = list(struct.unpack_from("B",ser.read(2),0))
                if end_angle < start_angle:
                        angle_res = ( end_angle + 360 - start_angle ) / 8.0
                else:
                        angle_res = ( end_angle - start_angle ) / 8.0
                for i in range(8):
                        j = 3 * i
                        lrange = int(frame_data[j+1]) << 8 | frame_data[j]
                        intensity = frame_data[j+2]
                        angle = int(round(start_angle + (angle_res * i)))
                        angle = 360 - angle
                        if lrange == 0x8000:
                                lrange = 8000
                        else:
                                pass
                        if angle >= 0:
                                ranges[angle] = float(lrange)/1000.0
                                intensities[angle] = intensity
                        else:
                                pass
                if end_angle < start_angle:
                        print "***********  DATA OUT *************"
                        print "start angle",
                        print start_angle
                        print "end angle",
                        print end_angle
                        print "speed",
                        print speed
                        print "angle res",
                        print angle_res
                        print "ranges",
                        print ranges
                        print "intensiteies",
                        print intensities
                        State = 'SYNC1'
                        break
                State = 'SYNC1'
        else:
                pass

dist = plt.subplot(111, polar = True)

def prot():
        for i in range(360):
              y[i] = i * math.pi / 180
              x[i] = ranges[i]
        plt.cla()
        dist.scatter(y, x, c = "blue", s = 5)
        dist.set_theta_offset(math.pi / 2)
        dist.set_rmax(2)
        dist.spines['polar'].set_visible(False)
        plt.pause(0.01)
        print("plot")

while True:
        CamsenseX1_parse()
        prot()
