#!/usr/bin/env python
# -*- coding: utf-8 -*-
import rospy
from sensor_msgs.msg import Joy
import time
import output_drive as p4robo

#R}h`

STOP = 0
FW = 1
RW = 2
CW = 3
CCW = 4
BRK = 9
OFF = 0
ON = 1

CAM_RL = 0
CAM_EL = 1

def joy_contrl(joy_msg):
    lx = joy_msg.axes[0]
    ly = joy_msg.axes[1]
    rx = joy_msg.axes[3]
    ry = joy_msg.axes[4]

    xspd = int(100 * abs(lx))
    yspd = int(100 * abs(ly))

    if xspd > 100 :
       xspd = 100
    elif xspd < 0:
       xspd = 0
    if yspd > 100 :
       yspd = 100
    elif yspd < 0:
       yspd = 0

    if joy_msg.buttons[1]== 1:
        print("Brake!!")
        p4robo.Move_Cntrl(BRK,0)
        time.sleep(1)
    elif (lx == 0) and (ly == 0 ):
        print("STOP")
        p4robo.Move_Cntrl(STOP,0)
    elif ly == 0:
       if lx > 0:
           print ("CW")
           p4robo.Move_Cntrl(CW,xspd)
       else:
           print ("CCW")
           p4robo.Move_Cntrl(CCW,xspd)
    elif lx == 0:
       if ly > 0:
           print("FW")
           p4robo.Move_Cntrl(FW,yspd)
       else:
           print("RW")
           p4robo.Move_Cntrl(RW,yspd)
    else:
       pass

    cam_or = 90 + (rx*25)
    cam_el = 60 + (ry*50)
    if cam_el < 50 :
       cam_el = 50
    p4robo.setServo(CAM_RL,cam_or)
    p4robo.setServo(CAM_EL,cam_el)

    if joy_msg.buttons[10] == 1:
       p4robo.Pl_port_out(1,HIGH)
    else:
       p4robo.Pl_port_out(1,LOW)

    if joy_msg.buttons[11] == 1:
       p4robo.Pl_port_out(2,HIGH)
    else:
       p4robo.Pl_port_out(2,LOW)

    if joy_msg.buttons[12] == 1:
       p4robo.Pl_port_out(3,HIGH)
    else:
       p4robo.Pl_port_out(3,LOW)

    if joy_msg.buttons[13] == 1:
       p4robo.Sol_Cntrl(ON)
    else:
       p4robo.Sol_Cntrl(OFF)


rospy.init_node('Joy2Robo')
rospy.Subscriber('joy', Joy, joy_contrl)
rospy.spin()

